extends Node

@onready var menu_position=0.0
@onready var game_position=0.0
@onready var puzzle_position=0.0

var game_songs = [
	preload("res://assets/music/game/Arabesca.MP3"),
	preload("res://assets/music/game/Arabesken (Zierau, Fritz) - Walzer (No.7).mp3"),
	preload("res://assets/music/game/Debussy_Arabesque_no_2.mp3"),
	preload("res://assets/music/game/Hoch_Vom_Dachstein_an_Fantasie.mp3"),
	preload("res://assets/music/game/Yuferov_Sergey-6_Arabesques_Op1-Elegie.mp3")
]

@onready var current_game_music_index = -1

func play_menu_music():
	$MenuMusic.play(self.menu_position)
	
func pause_menu_music():
	self.menu_position = $MenuMusic.get_playback_position()
	$MenuMusic.stop()
	
func play_game_music():
	if $GameMusic.stream == null:
		choose_random_game_song()
		
	$GameMusic.play(self.game_position)
	
func pause_game_music():
	self.game_position = $GameMusic.get_playback_position()
	$GameMusic.stop()
	
func play_puzzle_music():
	choose_random_game_song() # For next game song	
	$PuzzleMusic.play(self.puzzle_position)
	
func pause_puzzle_music():
	self.puzzle_position = $PuzzleMusic.get_playback_position()
	$PuzzleMusic.stop()
	
func choose_random_game_song()->void:
	self.game_position=0.0
	randomize()
	var new_song_index = current_game_music_index
	while new_song_index == current_game_music_index:
		new_song_index = randi() % game_songs.size()
	print(new_song_index)
	current_game_music_index = new_song_index
	$GameMusic.stream = game_songs[new_song_index]

func _on_game_music_finished() -> void:
	choose_random_game_song()
	$GameMusic.play()


func _on_puzzle_music_finished() -> void:
	self.puzzle_position=0.0
	$PuzzleMusic.play()


func _on_menu_music_finished() -> void:
	self.menu_position=0.0
	$MenuMusic.play()
