extends CanvasLayer

func _ready() -> void:
	var loaded = $"/root/SettingsData".load_settings()
	if not loaded:
		$Settings.show()
	if self.visible:
		$"/root/BackgroundMusic".pause_game_music()
		$"/root/BackgroundMusic".play_menu_music()
	
func show_message(text):
	$Mensaje.text = text
	$Mensaje.show()

func _on_BotonInicio_pressed():
	get_tree().paused = false
	$"/root/BackgroundMusic".choose_random_game_song()
	get_tree().change_scene_to_file("res://src/pvp.tscn")

func _on_BotonAyuda_pressed():
	get_tree().paused = false
	var source = "res://src/tuto/step1.tscn"
	get_tree().change_scene_to_file.bind(source).call_deferred()

func _on_BotonResume_pressed():
	get_tree().paused = false
	hide()
	$"/root/BackgroundMusic".pause_menu_music()
	if $"/root/BackgroundMusic".game_position==0.0 and $"/root/BackgroundMusic".puzzle_position > 0.0:
		$"/root/BackgroundMusic".play_puzzle_music()
	elif $"/root/BackgroundMusic".puzzle_position==0.0 and $"/root/BackgroundMusic".game_position > 0.0:
		$"/root/BackgroundMusic".play_game_music()

func _on_BotonSettings_pressed():
	$Settings.show()


func _on_boton_puzzle_pressed() -> void:
	get_tree().paused = false
	get_tree().change_scene_to_file("res://src/puzzles/puzzle_switcher.tscn")


func _on_boton_cpu_pressed() -> void:
	get_tree().paused = false
	$"/root/BackgroundMusic".choose_random_game_song()
	get_tree().change_scene_to_file("res://src/solo_mode/select_difficulty.tscn")


func _on_boton_credits_pressed() -> void:
	get_tree().paused = false
	get_tree().change_scene_to_file("res://src/thanks.tscn")
	
