class_name Marble extends RigidBody2D

enum {green, red, yellow}
const colors = [green, red, yellow]

var kept_during_jam_handling = false
@onready var felt_to_bottom = false
@onready var played_sfx = false
@onready var to_be_shaken = false


func set_color(id_color: int):
	var colores = get_colors()
	var color = colores[id_color]
	
	$Skin.animation = color
	
func set_color_by_name(color: String):
	$Skin.animation = color

func get_color():
	var color = $Skin.get_animation()
	return color

func get_color_id():
	var color = $Skin.get_animation()
	if color == "red":
		return red
	elif color == "green":
		return green
	elif color == "yellow":
		return yellow
	else:
		return -1
	

func get_colors():
	return $Skin.get_sprite_frames().get_animation_names()


func _on_body_entered(body: Node) -> void:
	if body is Marble:
		$TwoMarblesCollision.play()
	elif not played_sfx and felt_to_bottom : 
		if body.name == "BackBoard" :
			played_sfx = true
			$FallToBasket.play()
