extends Node

@onready var current_puzzle = $SelectPuzzle

func _ready() -> void:
	current_puzzle.gotopuzzle.connect(handle_puzzle_change)
	
func handle_puzzle_change(puzzle_level_number: int):
	var puzzle_level_name = "000" + str(puzzle_level_number)
	
	puzzle_level_name = puzzle_level_name.substr(len(puzzle_level_name)-2)
	#get_tree().change_scene_to_file("res://src/puzzles/puzzle_" + extra_arg_0 + ".tscn")
	var scn_source = "res://src/puzzles/puzzle_" + puzzle_level_name + ".tscn"
	var new_scene = load(scn_source).instantiate()
	add_child(new_scene)
	new_scene.find_child("PopupSolved").gotopuzzle.connect(handle_puzzle_change)
	new_scene.find_child("PopupFail").gotopuzzle.connect(handle_puzzle_change)
	new_scene.find_child("PuzzleCommon").gotopuzzle.connect(handle_puzzle_change)
	current_puzzle.queue_free()
	current_puzzle = new_scene
