extends Control

signal closing_settings
var lang = "en" 

func _ready() -> void:
	$"/root/SettingsData".load_settings()
	## Read from global settings
	var langs = {"en": 0, "es": 1, "fr":2}
	var lang_id = langs[$"/root/SettingsData".lang]
	%LangSelector.selected = lang_id
	
	TranslationServer.set_locale($"/root/SettingsData".lang)
	%p1name.text = $"/root/SettingsData".player1_name
	%p2name.text = $"/root/SettingsData".player2_name
	
	%Label1.text = tr("PLAYER") + " 1 :"
	%Label2.text = tr("PLAYER") + " 2 :"
	%LabelLang.text = tr("LANG_MENU") + " :"
	
	%MusicSettings.on_ready_volume($"/root/SettingsData".music_volume)
	%SoundSettings.on_ready_volume($"/root/SettingsData".sound_volume)
	

func _on_lang_selected(lang_id):
	lang = %LangSelector.get_item_text(lang_id)
	$"/root/SettingsData".lang = lang
	TranslationServer.set_locale(lang)
	%Label1.text = tr("PLAYER") + " 1 :"
	%Label2.text = tr("PLAYER") + " 2 :"
	%LabelLang.text = tr("LANG_MENU") + " :"

func _on_boton_volver_pressed() -> void:
	## Write into global settings
	$"/root/SettingsData".player1_name = %p1name.text 
	$"/root/SettingsData".player2_name = %p2name.text
	$"/root/SettingsData".music_volume = %MusicSettings.volume
	$"/root/SettingsData".sound_volume = %SoundSettings.volume
	$"/root/SettingsData".save_settings()
	hide()
	closing_settings.emit()
