extends Node2D


# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	update_lang()
	
func update_lang():
	if $"/root/SettingsData".lang == "es":
		%credits_body.text = credits_es
		%assets_body.text = assets_es
		%cafe_body.text = cafe_es
	elif $"/root/SettingsData".lang == "fr":
		%credits_body.text = credits_fr
		%assets_body.text = assets_fr
		%cafe_body.text = cafe_fr
	else:
		%credits_body.text = credits_en
		%assets_body.text = assets_en
		%cafe_body.text = cafe_en



var cafe_fr = """\
[center]\
Si vous avez aimé ce jeu, 
pensez à m'offrir un café.\
[/center]"""

var cafe_en = """\
[center]\
If you enjoyed this game, 
consider invite me to a coffee.\
[/center]\
"""

var cafe_es = """[center]\
Si te ha gustado este juego, 
considera invitarme a un café.\
[/center]\
"""

var credits_es = """[center]\
[i]Cascada[/i] está realizado con [i]GODOT[/i] por 
[b]Miguel Páez[/b],
basado en el juego de mesa [i]Avalancha[/i]. 
El creador de la mecánica de [i]Avalancha[/i] es 
[b]Frank W. Sinden[/b]. 
El editor original del juego de mesa [i]Avalancha[/i] es [b]Parker[/b]. 
Éste es un proyecto opensource, no estoy asociado con ninguno de ellos de ninguna manera.
[/center]\
"""

var credits_en = """[center]\
[i]Cascada[/i] is made with [i]GODOT[/i] by 
[b]Miguel Páez[/b],
based in the board game [i]Avalanche[/i]. 
[i]Avalanche[/i]’s mechanics creator is 
[b]Frank W. Sinden[/b].
The original board game publisher of the board game [i]Avalanche[/i] is [b]Parker[/b]. 
This is an opensource project, I'm not associated with any of them in any way.\
[/center]\
"""

var credits_fr = """[center]\
[i]Cascada[/i] est réalisé avec [i]GODOT[/i] par 
[b]Miguel Páez[/b],
basé sur jeu de société [i]Avalanche[/i]. 
Le créateur de la mécanique d'[i]Avalanche[/i] est 
[b]Frank W. Sinden[/b]. 
L'éditeur original du jeu de société [i]Avalanche[/i] est [b]Parker[/b]. 
Il s'agit d'un projet opensource, je ne suis associé à aucun d'entre eux de quelque manière que ce soit.\
[/center]\
"""

var assets_es = """\
La trompeta es de Maksym Tarkhov. 
Tada Fanfare G por plasterbrain 
Trumpet Fail por Universfield. 
La Música clásica:
 · Nocturnes, Op.32 (Chopin, Frédéric)
 · 3 Gymnopédies (Satie, Erik) Lent et douloureux (No.1)
 · 2 Arabesques (Debussy, Claude) No 2. Allegretto scherzando
 · Arabesken (Zierau, Fritz)  Walzer (No.7)
 · 6 Arabesques, Op.1 (Yuferov, Sergey)
 · Arabesca, Op.82 (Schwenkglenks, Manfred)
 · Arabesken, Op.79 (Lange, Gustav) 4. Hoch vom Dachstein\
"""

var assets_en = """\
The trumpet asset is from Maksym Tarkhov. 
Tada Fanfare G by plasterbrain.  
Trumpet Fail by Universfield.  
Classical music:
 · Nocturnes, Op.32 (Chopin, Frédéric)
 · 3 Gymnopédies (Satie, Erik) Lent et douloureux (No.1)
 · 2 Arabesques (Debussy, Claude) No 2. Allegretto scherzando
 · Arabesken (Zierau, Fritz)  Walzer (No.7)
 · 6 Arabesques, Op.1 (Yuferov, Sergey)
 · Arabesca, Op.82 (Schwenkglenks, Manfred)
 · Arabesken, Op.79 (Lange, Gustav) 4. Hoch vom Dachstein\
"""

var assets_fr = """\
La trompette provient de Maksym Tarkhov. 
Tada Fanfare G par plasterbrain. 
Trumpet Fail par Universfield. 
La musique classique :
 · Nocturnes, Op.32 (Chopin, Frédéric)
 · 3 Gymnopédies (Satie, Erik) Lent et douloureux (No.1)
 · 2 Arabesques (Debussy, Claude) No 2. Allegretto scherzando
 · Arabesken (Zierau, Fritz)  Walzer (No.7)
 · 6 Arabesques, Op.1 (Yuferov, Sergey)
 · Arabesca, Op.82 (Schwenkglenks, Manfred)
 · Arabesken, Op.79 (Lange, Gustav) 4. Hoch vom Dachstein\
"""


func _on_texture_button_pressed() -> void:
	OS.shell_open("https://buymeacoffee.com/miguelython")
