extends Node2D


# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	$"/root/BackgroundMusic".pause_menu_music()
	update_lang()
	
func update_lang():
	if $"/root/SettingsData".lang == "es":
		%thx_body.text = thx_es
		%tip_body.text = tip_es
	elif $"/root/SettingsData".lang == "fr":
		%thx_body.text = thx_fr
		%tip_body.text = tip_fr
	else:
		%thx_body.text = thx_en
		%tip_body.text = tip_en


var thx_es = """[center] Gracias por completar el tutorial.
Ahora tienes todos los elementos necesarios para poder jugar.
[/center]
"""
var tip_es = """[center] Si quieres  entender mejor la mécanica del juego, aquí tienes algunos puzles para practicar.
[/center]
"""

var thx_en = """[center] Thank you for completing the tutorial.
You now have all the necessary elements to be able to play.
[/center]
"""
var tip_en = """[center]If you want to better understand the game mechanics, here are some puzzles to practice.
[/center]
"""

var thx_fr = """[center] Merci d'avoir terminé le tutoriel.
Vous disposez maintenant de tous les éléments nécessaires pour pouvoir jouer.
[/center]
"""
var tip_fr = """[center]Si vous souhaitez mieux comprendre les mécanismes du jeu, voici quelques puzzles pour vous entraîner.
[/center]
"""



func _on_boton_menu_pressed() -> void:
	$"/root/BackgroundMusic".pause_puzzle_music()
	$"/root/BackgroundMusic".play_menu_music()
	get_tree().change_scene_to_file("res://src/welcome_menu.tscn")


func _on_boton_problems_pressed() -> void:
	$"/root/BackgroundMusic".pause_puzzle_music()
	$"/root/BackgroundMusic".play_menu_music()
	get_tree().change_scene_to_file("res://src/puzzles/puzzle_switcher.tscn")
