extends Node2D

var text_es = """ 
[center]
¡Bienvenid@ a [i]Casacada[/i]!

En este tutorial aprenderás cómo jugar.

El primer jugador que consiga completar las nueve casillas de su objetivo en el orden de las flechas gana la partida.
[/center]
"""
var text_en = """ 
[center]
Welcome to [i]Casacada[/i]!

In this tutorial you will learn how to play.


The first player to complete the nine target spaces in the order of the arrows wins the game.
[/center]
"""
var text_fr = """ 
[center]
Bienvenu·e à [i]Casacada[/i] !

Dans ce tutoriel, vous apprendrez à jouer.

Le premier joueur à compléter les neuf cases dans l'ordre des flèches gagne la partie.
[/center]
"""

# Declare member variables here. 
var starting_time :int

var counting_stop_turn = 0

var p1score:int = 0
var p2score:int = 0
var p1turn:bool = true
var p2turn:bool = false
const VictoryScore:int = 9

var p1name:String = "null"
var p2name:String = "nullos"


func _ready():
	TranslationServer.set_locale($"/root/SettingsData".lang)
	update_lang()
	$"/root/BackgroundMusic".pause_menu_music()
	$"/root/BackgroundMusic".play_puzzle_music()
	
	## Start the scene PvP
	p1score = 0
	p2score = 0
	p1turn = true
	p2turn = false
	update_players_name()
	
	randomize()
	$Board.setup_gates(true, null) # true -> Random
		
	$Turno.text = tr("TUTO") + " 1/5"
	$Puntuacion_Player1.text = p1name + " : " + str(p1score) + "pts"
	$Puntuacion_Player2.text = p2name + " : " + str(p2score) + "pts"
	$FancyScoreBoard1.setup()
	$FancyScoreBoard2.setup()
	$FancyScoreBoard1.queue_redraw()
	$FancyScoreBoard2.queue_redraw()


func show_menu():
	$"/root/BackgroundMusic".pause_puzzle_music()
	$"/root/BackgroundMusic".play_menu_music()
	$HUD.show()
	get_tree().paused = true
	$HUD/HBoxContainer/VBoxContainer/BotonResume.disabled = false


func update_players_name():
	p1name = tr("PLAYER") + " 1"
	p2name = tr("PLAYER") + " 2"
	
	
func update_lang():
	if $"/root/SettingsData".lang == "es":
		$ColorRect/RichTextLabel.text = text_es
	elif $"/root/SettingsData".lang == "fr":
		$ColorRect/RichTextLabel.text = text_fr
	else:
		$ColorRect/RichTextLabel.text = text_en
		

func _on_next_step_pressed() -> void:
	var source = "res://src/tuto/step2.tscn"
	get_tree().change_scene_to_file.bind(source).call_deferred()
