extends GdUnitTestSuite

@warning_ignore('unused_parameter')
@warning_ignore('return_value_discarded')
const __source = 'res://src/marble.gd'
var marble_gd = preload(__source)

const time_up_long = 15000
const time_up_short = 10000

var setup_test_00 = [
	  [0,1,0],
	[0,-1,0,0],
	  [0,1,0],
	[0,1,0,0]
]
var setup_test_01 = [
	  [0,1,0],
	[0,1,-1,0],
	  [0,1,0],
	[0,1,0,0]
]
var setup_test_02 = [
	  [0,-1,0],
	[0,1,-1,0],
	  [0,1,0],
	[0,1,0,0]
]
var setup_test_06 = [
	  [-1,1,-1],
	[1,1,-1,1],
	  [1,1,-1],
	[-1,-1,1,1]
]
var setup_test_03 = [
	  [1,1,0],
	[-1,-1,0,0],
	  [1,1,0],
	[1,1,0,0]
]

var setup_marbles_00 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, null, null, null]
]
var setup_marbles_01 = [
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.red, marble_gd.red, null, marble_gd.red],
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.green, marble_gd.green, marble_gd.green, marble_gd.green]
]
var setup_marbles_02 = [
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.red,  null, marble_gd.red, marble_gd.red],
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.green, marble_gd.green, marble_gd.green, marble_gd.green]
]
var setup_marbles_03 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, marble_gd.yellow, null, null]
]
var setup_marbles_All = [
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.red, marble_gd.red, marble_gd.red, marble_gd.red],
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.green, marble_gd.green, marble_gd.green, marble_gd.green]
]


func test_block(launch_zone_name:String, setup_gates:Array, setup_marbles:Array,
	test_parameters := [
		["LaunchZone3", setup_test_06, setup_marbles_All], # Note if this test (ALL) it's the third one, it willl not pass
		["LaunchZone3", setup_test_06, setup_marbles_01],
		["LaunchZone3", setup_test_06, setup_marbles_02],
		]):
			
	var runner = scene_runner("res://src/pvp_trainning_room.tscn")
	var pvp_scn = runner.invoke("find_child", "Pvp")
	
	
	var zone2avoid = runner.invoke("find_child","ToBeAvoid")
	
	var board = pvp_scn.find_child("Board")
	
	board.clean_all()
	board.setup_internal_walls()
	var refs = board.setup_puzzle(setup_gates, setup_marbles)
	
	pvp_scn.launch_input_choice = launch_zone_name
	var marble_source = pvp_scn.find_child("Sources")
	marble_source.color = "green"
	pvp_scn.start_turn()
	
	#var marbles = []
	#var types = []
	#var names = []
	#var colors = []
	#for node in pvp_scn.get_children():
		#var node_class = node.get_class()
		#types.append(node_class)
		#names.append(node.name)
		#if node_class.ends_with("RigidBody2D") and not node.name.ends_with("Goal"):
			#colors.append(node.get_color())
			#marbles.append(node)
			
			
	await assert_signal(pvp_scn).wait_until(time_up_long).is_emitted("end_turn")

func test_close_path(launch_zone_name:String, setup_gates:Array, setup_marbles:Array,
	test_parameters := [
		["LaunchZone3", setup_test_00, setup_marbles_00],
		["LaunchZone3", setup_test_01, setup_marbles_00],
		]
):
	var runner = scene_runner("res://src/pvp_trainning_room.tscn")
	var pvp_scn = runner.invoke("find_child", "Pvp")
	
	
	var zone2avoid = runner.invoke("find_child","ToBeAvoid")
	
	var board = pvp_scn.find_child("Board")
	
	board.clean_all()
	board.setup_internal_walls()
	var refs = board.setup_puzzle(setup_gates, setup_marbles)
	pvp_scn.launch_input_choice = launch_zone_name
	var marble_source = pvp_scn.find_child("Sources")
	marble_source.color = "green"
	pvp_scn.start_turn()
	
	var marbles = []
	var types = []
	var names = []
	for node in pvp_scn.get_children():
		types.append(node.get_class())
		names.append(node.name)
		if node.name.ends_with("Marble"):
			marbles.append(node)
	
	await assert_signal(zone2avoid).wait_until(time_up_short).is_not_emitted("body_entered", marbles)
	
func test_second_marble(lane1:String, lane2:String, setup_gates:Array, setup_marbles:Array,
	test_parameters := [
		["LaunchZone4","LaunchZone3", setup_test_02, setup_marbles_00],
		["LaunchZone1","LaunchZone3", setup_test_03, setup_marbles_00],
		]
):	
	var runner = scene_runner("res://src/pvp_trainning_room.tscn")
	var pvp_scn = runner.invoke("find_child", "Pvp")
	
	
	var zone2avoid = runner.invoke("find_child","ToBeAvoid")
	
	var board = pvp_scn.find_child("Board")
	
	board.clean_all()
	board.setup_internal_walls()
	board.setup_puzzle(setup_gates, setup_marbles)
	
	pvp_scn.launch_input_choice = lane1
	var marble_source = pvp_scn.find_child("Sources")
	marble_source.color = "green"
	pvp_scn.start_turn()
	
	var marbles = []
	var types = []
	var names = []
	var colors = []
	for node in pvp_scn.get_children():
		var node_class = node.get_class()
		types.append(node_class)
		names.append(node.name)
		if node_class.ends_with("RigidBody2D") and not node.name.ends_with("Goal"):
			colors.append(node.get_color())
			marbles.append(node)
			
	assert_int(len(marbles)).is_equal(1)
			
	await assert_signal(pvp_scn).wait_until(time_up_short).is_emitted("end_turn")
	pvp_scn.launch_input_choice = lane2
	marble_source.color = "red"
	pvp_scn.start_turn()


	for node in pvp_scn.get_children():
		var node_class = node.get_class()
		types.append(node_class)
		names.append(node.name)
		if node_class.ends_with("RigidBody2D") and not node.name.ends_with("Goal"):
			var color = node.get_color()
			if color.ends_with("red"):
				colors.append(color)
				marbles.append(node)
				
	
	assert_int(len(marbles)).is_equal(2)
	
	await assert_signal(zone2avoid).wait_until(time_up_short).is_not_emitted("body_entered", [marbles[1]])
