# GdUnit generated TestSuite
class_name BoardTest
extends GdUnitTestSuite
@warning_ignore('unused_parameter')
@warning_ignore('return_value_discarded')

# TestSuite generated from
const __source = 'res://src/complete_board.gd'
var marble_gd = preload('res://src/marble.gd')

var setup_gates_00 = [
	  [1,1,-1],
	[1,-1,1,1],
	  [1,1,-1],
	[-1,-1,1,-1]
]
var setup_gates_01 = [
	  [1,1,1],
	[1,1,1,1],
	  [1,1,1],
	[1,1,1,1]
]
var setup_gates_02 = [
	  [-1,-1,-1],
	[-1,-1,-1,-1],
	  [-1,-1,-1],
	[-1,-1,-1,-1]
]
var setup_gates_03 = [
	  [-1,1,1],
	[1,1,-1,1],
	  [-1,1,1],
	[1,1,-1,1]
]

var setup_marbles_00 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, null, null, null]
]
var setup_marbles_01 = [
		   [marble_gd.green, null, null],
		[null, null, marble_gd.yellow, null],
		   [null, null, null],
		[null, marble_gd.red, null, marble_gd.green]
]
var setup_marbles_02 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, marble_gd.red, null, null]
]
var setup_marbles_03 = [
		   [ marble_gd.red, null, marble_gd.green],
		[null, marble_gd.green, null, marble_gd.green],
		   [marble_gd.yellow, null, null],
		[null, null, marble_gd.green, marble_gd.yellow]
]

func test_read_marbles(
	setup_marbles:Array,
	test_parameters := [
		[setup_marbles_00],
		[setup_marbles_01],
		[setup_marbles_02],
		[setup_marbles_03],
		]
) -> void:
	var runner = scene_runner("res://src/pvp_trainning_room.tscn")
	var pvp_scn = runner.invoke("find_child", "Pvp")
	var board = pvp_scn.find_child("Board")
	
	board.clean_all()
	board.setup_internal_walls()
	var refs = board.setup_puzzle(setup_gates_00, setup_marbles)
	await await_millis(100)
	var read_marbles = board.read_marbles()
	assert_array(setup_marbles).is_equal(read_marbles)

func test_read_gates(
	setup_gates:Array,
	test_parameters := [
		[setup_gates_00],
		[setup_gates_01],
		[setup_gates_02],
		[setup_gates_03],
		]
) -> void:
	var runner = scene_runner("res://src/pvp_trainning_room.tscn")
	var pvp_scn = runner.invoke("find_child", "Pvp")
	var board = pvp_scn.find_child("Board")
	
	board.clean_all()
	board.setup_internal_walls()
	var refs = board.setup_puzzle(setup_gates, setup_marbles_00)
	await await_millis(100)
	var read_gates = board.read_gates()
	assert_array(setup_gates).is_equal(read_gates)
