extends GdUnitTestSuite
@warning_ignore('unused_parameter')
@warning_ignore('return_value_discarded')
const __source = 'res://src/marble.gd'
var marble_gd = preload(__source)

var setup_test_00 = [
	  [0,1,0],
	[0,-1,0,0],
	  [0,1,0],
	[0,-1,0,0]
]

var setup_test_01 = [
	  [0,-1,0],
	[0,-1,0,0],
	  [0,1,0],
	[0,-1,0,0]
]

var setup_test_02 = [
	  [0,-1,0],
	[0,0,1,0],
	  [0,-1,0],
	[0,0,1,0]
]
var setup_test_03 = [
	  [0,1,0],
	[0,1,-1,0],
	  [-1,-1,0],
	[0,1,1,0]
]

var setup_test_04 = [
	  [0,1,0],
	[0,1,-1,0],
	  [1,1,0],
	[0,-1,1,0]
]

var setup_test_05 = [
	  [0,1,-1],
	[0,1,-1,1],
	  [1,1,-1],
	[0,-1,1,1]
]

var setup_test_06 = [
	  [-1,1,-1],
	[1,1,-1,1],
	  [1,1,-1],
	[-1,-1,1,1]
]

var setup_marbles_00 = [
		   [null, null, null],
		[null, marble_gd.yellow, null, null],
		   [null, null, null],
		[null, null, null, null]
]

var setup_marbles_01 = [
		   [null, null, null],
		[null, marble_gd.red, null, null],
		   [null, null, null],
		[null, null, null, null]
]
var setup_marbles_02 = [
		   [null, null, marble_gd.yellow],
		[null, null, null, marble_gd.yellow],
		   [null, null, marble_gd.yellow],
		[null, null, null, marble_gd.yellow]
]
var setup_marbles_03 = [
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.red, marble_gd.red, marble_gd.red, marble_gd.red],
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.green, marble_gd.green, marble_gd.green, marble_gd.green]
]
func test_free_fall() -> void:
	var runner = scene_runner("res://src/free_fall_room.tscn")
	var marble = runner.invoke("find_child", "Marble")
	var zone = runner.invoke("find_child", "Validation")

	await assert_signal(zone).wait_until(2000).is_emitted("body_entered", [marble])

func test_puzzle_0() -> void:
	var runner = scene_runner("res://src/trainning_room.tscn")
	var marble = runner.invoke("find_child", "Marble")
	var zone = runner.invoke("find_child", "Validation")
	var board = runner.invoke("find_child", "Board")
	
	board.setup_puzzle(setup_test_03, setup_marbles_00)

	await assert_signal(zone).wait_until(7500).is_emitted("body_entered", [marble])
	
func test_puzzle_1() -> void:
	var runner = scene_runner("res://src/trainning_room.tscn")
	var zone = runner.invoke("find_child", "Validation")
	var board = runner.invoke("find_child", "Board")
	
	var refs = board.setup_puzzle(setup_test_04, setup_marbles_01)

	await assert_signal(zone).wait_until(9000).is_emitted("body_entered", refs)
	

func test_puzzle_2() -> void:
	var runner = scene_runner("res://src/trainning_room.tscn")
	var marble = runner.invoke("find_child", "Marble")
	var zone = runner.invoke("find_child", "Validation")
	var board = runner.invoke("find_child", "Board")
	
	marble.set_color(marble_gd.red)
	board.setup_puzzle(setup_test_06, setup_marbles_03)
	
	await assert_signal(zone).wait_until(7500).is_emitted("body_entered", [marble])
	
	
func test_puzzle_3() -> void:
	var runner = scene_runner("res://src/trainning_room.tscn")
	var marble = runner.invoke("find_child", "Marble")
	var zone = runner.invoke("find_child", "Validation")
	var board = runner.invoke("find_child", "Board")
	
	board.setup_puzzle(setup_test_05, setup_marbles_02)
	marble.position.x = 330.5
	
	await assert_signal(zone).wait_until(7500).is_emitted("body_entered", [marble])
	

func test_close_path() -> void:
	var runner = scene_runner("res://src/trainning_room.tscn")
	var marble = runner.invoke("find_child", "Marble")
	var zone = runner.invoke("find_child", "Validation")
	var board = runner.invoke("find_child", "Board")
	
	board.setup_gates(false,setup_test_01)
	
	await assert_signal(zone).wait_until(10000).is_not_emitted("body_entered", [marble])
