extends GdUnitTestSuite
@warning_ignore('unused_parameter')
@warning_ignore('return_value_discarded')
const __source = 'res://src/marble.gd'
var marble_gd = preload(__source)

var setup_test_1 = [
	  [1,0,0],
	[-1,0,0,0],
	  [1,0,0],
	[-1,0,0,0]
]

var setup_test_2 = [
	  [-1,0,0],
	[0,1,0,0],
	  [-1,0,0],
	[0,1,0,0]
]

var setup_test_3 = [
	  [0,1,0],
	 [0,-1,0,0],
	  [0,1,0],
	 [0,-1,0,0]
]
var setup_test_4 = [
	  [0,-1,0],
	[0,0,1,0],
	  [0,-1,0],
	[0,0,1,0]
]


var setup_test_5 = [
	  [0,0,1],
	[0,0,-1,0],
	  [0,0,1],
	[0,0,-1,0]
]

var setup_test_6 = [
	  [0,0,-1],
	[0,0,0,1],
	  [0,0,-1],
	[0,0,0,1]
]

var launch_script = preload('res://src/launch_zone.gd')
var x1 = launch_script.x0 + launch_script.x_increment * 1
var x2 = launch_script.x0 + launch_script.x_increment * 2
var x3 = launch_script.x0 + launch_script.x_increment * 3
var x4 = launch_script.x0 + launch_script.x_increment * 4
var x5 = launch_script.x0 + launch_script.x_increment * 5
var x6 = launch_script.x0 + launch_script.x_increment * 6

func test_open_path(marble_x: float, marble_y: float, setup_test: Array, 
	test_parameters := [
		[x1, launch_script.y0, setup_test_1],
		[x2, launch_script.y0, setup_test_2],
		[x3, launch_script.y0, setup_test_3],
		[x4, launch_script.y0, setup_test_4],
		[x5, launch_script.y0, setup_test_5],
		[x6, launch_script.y0, setup_test_6],
		]
) -> void:
	var runner = scene_runner("res://src/trainning_room.tscn")
	var marble = runner.invoke("find_child", "Marble")
	var zone = runner.invoke("find_child", "Validation")
	var board = runner.invoke("find_child", "Board")
	
	board.setup_gates(false,setup_test)
	
	marble.position.x = marble_x
	marble.position.y = marble_y
	
	await assert_signal(zone).wait_until(4000).is_emitted("body_entered", [marble])
	
