extends GdUnitTestSuite
@warning_ignore('unused_parameter')
@warning_ignore('return_value_discarded')
const __scene = 'res://src/puzzles/puzzle_01.tscn'

var colors = ["green", "red", "yellow"]
var time_out = 10000

func test_puzzle_01(success_expected: bool, lane: int, color: String, 
	test_parameters := [
		#[false, 0, colors[0]],
		#[false, 1, colors[0]],
		[true, 2, colors[0]],
		#[false, 3, colors[0]],
		#[false, 4, colors[0]],
		#[false, 5, colors[0]],
		#[false, 0, colors[1]],
		#[false, 1, colors[1]],
		[false, 2, colors[1]],
		#[false, 3, colors[1]],
		#[false, 4, colors[1]],
		#[false, 5, colors[1]],
		#[false, 0, colors[2]],
		#[false, 1, colors[2]],
		#[false, 2, colors[2]],
		#[false, 3, colors[2]],
		#[false, 4, colors[2]],
		#[false, 5, colors[2]],
		]
) -> void:
	var runner = scene_runner('res://src/puzzles/puzzle_01.tscn')
	var puzzle = runner.invoke("find_child", "PuzzleCommon")
	var marble_source = puzzle.find_child("Sources")
	var popup_success = runner.invoke("find_child","PopupSolved")
	var popup_fail = runner.invoke("find_child","PopupFail")
	marble_source.color = color
	var launch_zone_name = "LaunchZone" + str(lane + 1)
	puzzle.launch_input_choice = launch_zone_name
	puzzle.run_puzzle()
	#await assert_signal(puzzle).wait_until(time_out).is_emitted("end_turn")
	if success_expected:
		await assert_signal(popup_success).wait_until(time_out).is_emitted("visibility_changed")
	else:
		await assert_signal(popup_fail).wait_until(time_out).is_emitted("visibility_changed")

func test_puzzle_02(success_expected: bool, lane: int, color: String, 
	test_parameters := [
		#[false, 0, colors[0]],
		#[false, 1, colors[0]],
		#[false, 2, colors[0]],
		#[false, 3, colors[0]],
		#[false, 4, colors[0]],
		[false, 5, colors[0]],
		#[false, 0, colors[1]],
		#[false, 1, colors[1]],
		#[false, 2, colors[1]],
		#[false, 3, colors[1]],
		#[false, 4, colors[1]],
		#[false, 5, colors[1]],
		#[false, 0, colors[2]],
		#[false, 1, colors[2]],
		#[false, 2, colors[2]],
		#[false, 3, colors[2]],
		#[false, 4, colors[2]],
		[true, 5, colors[2]],
		]
) -> void:
	var runner = scene_runner('res://src/puzzles/puzzle_02.tscn')
	var puzzle = runner.invoke("find_child", "PuzzleCommon")
	var marble_source = puzzle.find_child("Sources")
	var popup_success = runner.invoke("find_child","PopupSolved")
	var popup_fail = runner.invoke("find_child","PopupFail")
	marble_source.color = color
	var launch_zone_name = "LaunchZone" + str(lane + 1)
	puzzle.launch_input_choice = launch_zone_name
	puzzle.run_puzzle()
	#await assert_signal(puzzle).wait_until(time_out).is_emitted("end_turn")
	if success_expected:
		await assert_signal(popup_success).wait_until(time_out).is_emitted("visibility_changed")
	else:
		await assert_signal(popup_fail).wait_until(time_out).is_emitted("visibility_changed")


func test_puzzle_03(success_expected: bool, lane: int, color: String, 
	test_parameters := [
		#[false, 0, colors[0]],
		#[false, 1, colors[0]],
		[false, 2, colors[0]],
		#[false, 3, colors[0]],
		#[false, 4, colors[0]],
		#[false, 5, colors[0]],
		#[false, 0, colors[1]],
		#[false, 1, colors[1]],
		[true, 2, colors[1]],
		#[false, 3, colors[1]],
		#[false, 4, colors[1]],
		#[false, 5, colors[1]],
		#[false, 0, colors[2]],
		#[false, 1, colors[2]],
		#[false, 2, colors[2]],
		#[false, 3, colors[2]],
		#[false, 4, colors[2]],
		#[false, 5, colors[2]],
		]
) -> void:
	var runner = scene_runner('res://src/puzzles/puzzle_03.tscn')
	var puzzle = runner.invoke("find_child", "PuzzleCommon")
	var marble_source = puzzle.find_child("Sources")
	var popup_success = runner.invoke("find_child","PopupSolved")
	var popup_fail = runner.invoke("find_child","PopupFail")
	marble_source.color = color
	var launch_zone_name = "LaunchZone" + str(lane + 1)
	puzzle.launch_input_choice = launch_zone_name
	puzzle.run_puzzle()
	#await assert_signal(puzzle).wait_until(time_out).is_emitted("end_turn")
	if success_expected:
		await assert_signal(popup_success).wait_until(time_out).is_emitted("visibility_changed")
	else:
		await assert_signal(popup_fail).wait_until(time_out).is_emitted("visibility_changed")


func test_puzzle_04(success_expected: bool, lane: int, color: String, 
	test_parameters := [
		#[false, 0, colors[0]],
		#[false, 1, colors[0]],
		#[false, 2, colors[0]],
		#[false, 3, colors[0]],
		#[false, 4, colors[0]],
		[true, 5, colors[0]],
		#[false, 0, colors[1]],
		#[false, 1, colors[1]],
		#[false, 2, colors[1]],
		#[false, 3, colors[1]],
		#[false, 4, colors[1]],
		[false, 5, colors[1]],
		#[false, 0, colors[2]],
		#[false, 1, colors[2]],
		#[false, 2, colors[2]],
		#[false, 3, colors[2]],
		#[false, 4, colors[2]],
		#[false, 5, colors[2]],
		]
) -> void:
	var runner = scene_runner('res://src/puzzles/puzzle_04.tscn')
	var puzzle = runner.invoke("find_child", "PuzzleCommon")
	var marble_source = puzzle.find_child("Sources")
	var popup_success = runner.invoke("find_child","PopupSolved")
	var popup_fail = runner.invoke("find_child","PopupFail")
	marble_source.color = color
	var launch_zone_name = "LaunchZone" + str(lane + 1)
	puzzle.launch_input_choice = launch_zone_name
	puzzle.run_puzzle()
	#await assert_signal(puzzle).wait_until(time_out).is_emitted("end_turn")
	if success_expected:
		await assert_signal(popup_success).wait_until(time_out).is_emitted("visibility_changed")
	else:
		await assert_signal(popup_fail).wait_until(time_out).is_emitted("visibility_changed")


func test_puzzle_05(success_expected: bool, lane: int, color: String, 
	test_parameters := [
		#[false, 0, colors[0]],
		#[false, 1, colors[0]],
		#[false, 2, colors[0]],
		#[false, 3, colors[0]],
		#[false, 4, colors[0]],
		#[false, 5, colors[0]],
		[false, 0, colors[1]],
		#[false, 1, colors[1]],
		#[false, 2, colors[1]],
		#[false, 3, colors[1]],
		#[false, 4, colors[1]],
		#[false, 5, colors[1]],
		[true, 0, colors[2]],
		#[false, 1, colors[2]],
		#[false, 2, colors[2]],
		#[false, 3, colors[2]],
		#[false, 4, colors[2]],
		#[false, 5, colors[2]],
		]
) -> void:
	var runner = scene_runner('res://src/puzzles/puzzle_05.tscn')
	var puzzle = runner.invoke("find_child", "PuzzleCommon")
	var marble_source = puzzle.find_child("Sources")
	var popup_success = runner.invoke("find_child","PopupSolved")
	var popup_fail = runner.invoke("find_child","PopupFail")
	marble_source.color = color
	var launch_zone_name = "LaunchZone" + str(lane + 1)
	puzzle.launch_input_choice = launch_zone_name
	puzzle.run_puzzle()
	#await assert_signal(puzzle).wait_until(time_out).is_emitted("end_turn")
	if success_expected:
		await assert_signal(popup_success).wait_until(time_out).is_emitted("visibility_changed")
	else:
		await assert_signal(popup_fail).wait_until(time_out).is_emitted("visibility_changed")


func test_puzzle_06(success_expected: bool, lane: int, color: String, 
	test_parameters := [
		#[false, 0, colors[0]],
		#[false, 1, colors[0]],
		#[false, 2, colors[0]],
		[true, 3, colors[0]],
		#[false, 4, colors[0]],
		#[false, 5, colors[0]],
		#[false, 0, colors[1]],
		#[false, 1, colors[1]],
		#[false, 2, colors[1]],
		[false, 3, colors[1]],
		#[false, 4, colors[1]],
		#[false, 5, colors[1]],
		#[false, 0, colors[2]],
		#[false, 1, colors[2]],
		#[false, 2, colors[2]],
		#[false, 3, colors[2]],
		#[false, 4, colors[2]],
		#[false, 5, colors[2]],
		]
) -> void:
	var runner = scene_runner('res://src/puzzles/puzzle_06.tscn')
	var puzzle = runner.invoke("find_child", "PuzzleCommon")
	var marble_source = puzzle.find_child("Sources")
	var popup_success = runner.invoke("find_child","PopupSolved")
	var popup_fail = runner.invoke("find_child","PopupFail")
	marble_source.color = color
	var launch_zone_name = "LaunchZone" + str(lane + 1)
	puzzle.launch_input_choice = launch_zone_name
	puzzle.run_puzzle()
	#await assert_signal(puzzle).wait_until(time_out).is_emitted("end_turn")
	if success_expected:
		await assert_signal(popup_success).wait_until(time_out).is_emitted("visibility_changed")
	else:
		await assert_signal(popup_fail).wait_until(time_out).is_emitted("visibility_changed")


func test_puzzle_07(success_expected: bool, lane: int, color: String, 
	test_parameters := [
		#[false, 0, colors[0]],
		#[false, 1, colors[0]],
		#[false, 2, colors[0]],
		#[false, 3, colors[0]],
		#[false, 4, colors[0]],
		[false, 5, colors[0]],
		#[false, 0, colors[1]],
		#[false, 1, colors[1]],
		#[false, 2, colors[1]],
		#[false, 3, colors[1]],
		#[false, 4, colors[1]],
		[true, 5, colors[1]],
		#[false, 0, colors[2]],
		#[false, 1, colors[2]],
		#[false, 2, colors[2]],
		#[false, 3, colors[2]],
		#[false, 4, colors[2]],
		#[false, 5, colors[2]],
		]
) -> void:
	var runner = scene_runner('res://src/puzzles/puzzle_07.tscn')
	var puzzle = runner.invoke("find_child", "PuzzleCommon")
	var marble_source = puzzle.find_child("Sources")
	var popup_success = runner.invoke("find_child","PopupSolved")
	var popup_fail = runner.invoke("find_child","PopupFail")
	marble_source.color = color
	var launch_zone_name = "LaunchZone" + str(lane + 1)
	puzzle.launch_input_choice = launch_zone_name
	puzzle.run_puzzle()
	#await assert_signal(puzzle).wait_until(time_out).is_emitted("end_turn")
	if success_expected:
		await assert_signal(popup_success).wait_until(time_out).is_emitted("visibility_changed")
	else:
		await assert_signal(popup_fail).wait_until(time_out).is_emitted("visibility_changed")


func test_puzzle_08(success_expected: bool, lane: int, color: String, 
	test_parameters := [
		#[false, 0, colors[0]],
		#[false, 1, colors[0]],
		#[false, 2, colors[0]],
		#[false, 3, colors[0]],
		#[false, 4, colors[0]],
		#[false, 5, colors[0]],
		#[false, 0, colors[1]],
		[true, 1, colors[1]],
		[true, 2, colors[1]],
		#[false, 3, colors[1]],
		#[false, 4, colors[1]],
		#[false, 5, colors[1]],
		#[false, 0, colors[2]],
		#[false, 1, colors[2]],
		[false, 2, colors[2]],
		#[false, 3, colors[2]],
		#[false, 4, colors[2]],
		#[false, 5, colors[2]],
		]
) -> void:
	var runner = scene_runner('res://src/puzzles/puzzle_08.tscn')
	var puzzle = runner.invoke("find_child", "PuzzleCommon")
	var marble_source = puzzle.find_child("Sources")
	var popup_success = runner.invoke("find_child","PopupSolved")
	var popup_fail = runner.invoke("find_child","PopupFail")
	marble_source.color = color
	var launch_zone_name = "LaunchZone" + str(lane + 1)
	puzzle.launch_input_choice = launch_zone_name
	puzzle.run_puzzle()
	#await assert_signal(puzzle).wait_until(time_out).is_emitted("end_turn")
	if success_expected:
		await assert_signal(popup_success).wait_until(time_out).is_emitted("visibility_changed")
	else:
		await assert_signal(popup_fail).wait_until(time_out).is_emitted("visibility_changed")


func test_puzzle_09(success_expected: bool, lane: int, color: String, 
	test_parameters := [
		#[false, 0, colors[0]],
		#[false, 1, colors[0]],
		#[false, 2, colors[0]],
		[false, 3, colors[0]],
		#[false, 4, colors[0]],
		#[false, 5, colors[0]],
		#[false, 0, colors[1]],
		#[false, 1, colors[1]],
		#[false, 2, colors[1]],
		[true, 3, colors[1]],
		#[false, 4, colors[1]],
		#[false, 5, colors[1]],
		#[false, 0, colors[2]],
		#[false, 1, colors[2]],
		#[false, 2, colors[2]],
		#[false, 3, colors[2]],
		#[false, 4, colors[2]],
		[true, 5, colors[2]],
		]
) -> void:
	var runner = scene_runner('res://src/puzzles/puzzle_09.tscn')
	var puzzle = runner.invoke("find_child", "PuzzleCommon")
	var marble_source = puzzle.find_child("Sources")
	var popup_success = runner.invoke("find_child","PopupSolved")
	var popup_fail = runner.invoke("find_child","PopupFail")
	marble_source.color = color
	var launch_zone_name = "LaunchZone" + str(lane + 1)
	puzzle.launch_input_choice = launch_zone_name
	puzzle.run_puzzle()
	#await assert_signal(puzzle).wait_until(time_out).is_emitted("end_turn")
	if success_expected:
		await assert_signal(popup_success).wait_until(time_out).is_emitted("visibility_changed")
	else:
		await assert_signal(popup_fail).wait_until(time_out).is_emitted("visibility_changed")
