extends GdUnitTestSuite

@warning_ignore('unused_parameter')
@warning_ignore('return_value_discarded')
const __source = 'res://src/marble.gd'
var marble_gd = preload(__source)

const time_up = 7000

var setup_test_00 = [
	  [0,0,0],
	[0,0,0,0],
	  [0,0,0],
	[0,0,0,0]
]

var setup_test_01 = [
	  [0,1,0],
	[0,-1,0,0],
	  [0,1,0],
	[0,1,0,0]
]


var setup_test_02 = [
	  [0,1,0],
	[0,-1,0,0],
	  [0,1,0],
	[0,-1,0,0]
]


var setup_test_03 = [
	  [1,0,0],
	[-1,0,0,0],
	  [1,0,0],
	[-1,0,0,0]
]


var setup_test_04 = [
	  [0,0,-1],
	[0,0,0,1],
	  [0,0,-1],
	[0,0,0,1]
]

var setup_marbles_00 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, null, null, null]
]

var setup_marbles_01 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, marble_gd.red, null, null]
]

var setup_marbles_02= [
		   [null, null, null],
		[marble_gd.red, null, null, null],
		   [null, null, null],
		[null, null, null, null]
]

var setup_marbles_03= [
		   [null, null, null],
		[null, null, null, marble_gd.red],
		   [null, null, null],
		[null, null, null, null]
]

func test_score(launch_zone_name:String, initial_score:int, expected_score:int, setup_gates:Array, setup_marbles:Array,
	test_parameters := [
		["LaunchZone3", 0,1,setup_test_02, setup_marbles_00],
		["LaunchZone3", 0,2,setup_test_02, setup_marbles_01],
		["LaunchZone6", 0,2,setup_test_04, setup_marbles_03],
		["LaunchZone1", 0,2,setup_test_03, setup_marbles_02],
		["LaunchZone3", 8,9,setup_test_02, setup_marbles_00],
		["LaunchZone3", 0,0,setup_test_01, setup_marbles_00],
		]
):
	var runner = scene_runner("res://src/pvp_trainning_room.tscn")
	var pvp_scn = runner.invoke("find_child", "Pvp")
	
	
	var board = pvp_scn.find_child("Board")
	var score_board = pvp_scn.find_child("FancyScoreBoard1")
	score_board.target_marbles = [0,1,1,1,1,1,1,1,0]
	pvp_scn.p1score = initial_score
	
	board.clean_all()
	board.setup_internal_walls()
	board.setup_puzzle(setup_gates, setup_marbles)
	pvp_scn.launch_input_choice = launch_zone_name
	var marble_source = pvp_scn.find_child("Sources")
	marble_source.color = "green"
	pvp_scn.start_turn()
	
	await assert_signal(pvp_scn).wait_until(time_up).is_emitted("end_turn")
	
	assert_int(pvp_scn.p1score).is_equal(expected_score)
	
	if expected_score == 9:
		await await_millis(3000)
