# GdUnit generated TestSuite
class_name MarbleTest
extends GdUnitTestSuite
@warning_ignore('unused_parameter')
@warning_ignore('return_value_discarded')

# TestSuite generated from
const __source = 'res://src/marble.gd'

var marble = null
var marble_scn = null

func before_test():
	marble = auto_free(preload(__source).new())
	marble_scn = auto_free(preload('res://src/marble.tscn').instantiate())

func test_collision_node_exists_in_scn() -> void:
	var collision_node = marble_scn.get_node("CollisionShape2D")
	assert_str(collision_node.get_class()).is_equal("CollisionShape2D")
	
func test_skin_node_exists_in_scn() -> void:
	var sprite_node = marble_scn.get_node("Skin")
	assert_str(sprite_node.get_class()).is_equal("AnimatedSprite2D")
	
	
func test_set_color() -> void:
	marble_scn.set_color(marble.yellow)
	var color = marble_scn.get_color()
	assert_that(color).is_equal("yellow")
	
func test_set_color_by_name() -> void:
	marble_scn.set_color_by_name("red")
	var color = marble_scn.get_color()
	assert_that(color).is_equal("red")
	
func test_get_color() -> void:
	var color = marble_scn.get_color()
	assert_that(color).is_equal("green")
	
	
func test_get_colors() -> void:
	var color = marble_scn.get_colors()
	assert_that(color).is_equal(["green", "red", "yellow"])
