# GdUnit generated TestSuite
class_name AnalyticSolverTest
extends GdUnitTestSuite
@warning_ignore('unused_parameter')
@warning_ignore('return_value_discarded')

# TestSuite generated from
const __source = 'res://src/solo_mode/analytic_solver.gd'
var solver_src = preload(__source)
var marble = preload('res://src/marble.gd')

var launch_zone_test_00 = 0
var color_marble_test_00 = marble.red
var setup_test_00 = [
	  [0,0,0],
	[0,0,0,0],
	  [0,0,0],
	[0,0,0,0]
]
var setup_test_01 = [
	  [1,1,1],
	[0,0,0,0],
	  [0,0,0],
	[0,0,0,0]
]
var setup_test_02 = [
	  [-1,-1,-1],
	[0,0,0,0],
	  [0,0,0],
	[0,0,0,0]
]
var setup_test_10 = [
	  [0,1,0],
	[0,-1,0,0],
	  [0,1,0],
	[0,1,0,0]
]

var setup_marbles_null = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, null, null, null]
]


var open_path_0 = [
	  [1,0,0],
	[-1,0,0,0],
	  [1,0,0],
	[-1,0,0,0]
]

var open_path_1 = [
	  [-1,0,0],
	[0,1,0,0],
	  [-1,0,0],
	[0,1,0,0]
]

var open_path_2 = [
	  [0,1,0],
	 [0,-1,0,0],
	  [0,1,0],
	 [0,-1,0,0]
]
var open_path_3 = [
	  [0,-1,0],
	[0,0,1,0],
	  [0,-1,0],
	[0,0,1,0]
]


var open_path_4 = [
	  [0,0,1],
	[0,0,-1,0],
	  [0,0,1],
	[0,0,-1,0]
]

var open_path_5 = [
	  [0,0,-1],
	[0,0,0,1],
	  [0,0,-1],
	[0,0,0,1]
]

var semi_open_path_0 = [
	  [1,0,0],
	[-1,0,0,0],
	  [1,0,0],
	[1,0,0,0]
]
var setup_marbles_0 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[marble.red, null, null, null]
]
var semi_open_path_1 = [
	  [-1,0,0],
	[0,1,0,0],
	  [-1,0,0],
	[0,-1,0,0]
]

var semi_open_path_2 = [
	  [0,1,0],
	 [0,-1,0,0],
	  [0,1,0],
	 [0,1,0,0]
]
var close_path_0 = [
	  [-1,1,1],
	 [1,-1,-1,1],
	  [1,1,-1],
	 [-1,1,1,-1]
]

var open_lvl0_gates_0 = [1, 2, 4]

var close_path_1 = [
	  [1,1,1],
	 [1,-1,-1,1],
	  [1,1,-1],
	 [-1,1,1,-1]
]

var open_lvl0_gates_1 = [0, 2, 4]

var close_path_2 = [
	  [-1,-1,-1],
	 [1,-1,-1,1],
	  [1,1,-1],
	 [-1,1,1,-1]
]

var open_lvl0_gates_2 = [1, 3, 5]

var close_path_3 = [
	  [-1,1,-1],
	 [1,-1,-1,1],
	  [1,1,-1],
	 [-1,1,1,-1]
]

var open_lvl0_gates_3 = [1, 2, 5]

var close_path_4 = [
	  [1,1,-1],
	 [1,1,1,1],
	  [1,1,-1],
	 [-1,1,-1,1]
]

var setup_marbles_1 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, marble.green, null, null]
]

var semi_open_path_3 = [
	  [0,-1,0],
	[0,0,1,0],
	  [0,-1,0],
	[0,0,-1,0]
]

var semi_open_path_4 = [
	  [0,0,1],
	[0,0,-1,0],
	  [0,0,1],
	[0,0,1,0]
]

var setup_marbles_2 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, null, marble.yellow, null]
]

var semi_open_path_5 = [
	  [0,0,-1],
	[0,0,0,1],
	  [0,0,-1],
	[0,0,0,-1]
]

var setup_marbles_3 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, null, null, marble.red]
]

var setup_marbles_4 = [
		   [null, null, null],
		[null, null, marble.yellow, null],
		   [null, null, null],
		[null, marble.green, null, marble.red]
]
var setup_marbles_5 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, marble.red],
		[null, null, null, null]
]

func test_close_path_00(
	  input_zone: int, 
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
		[0, setup_test_00, setup_marbles_null],
		[1, setup_test_00, setup_marbles_null],
		[2, setup_test_00, setup_marbles_null],
		[3, setup_test_00, setup_marbles_null],
		[4, setup_test_00, setup_marbles_null],
		[5, setup_test_00, setup_marbles_null]
		]
	) -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(
		input_zone,
		marble.red,
		gates_setup, 
		marbles_setup)
		
	var next_marbles = next_state["marbles"]
	assert_that(next_marbles[0][input_zone/2]).is_not_null()
	
	var next_gates = next_state["gates"]
	assert_that(next_gates[0][input_zone/2]).is_not_equal(0)

func test_close_path_01(
	  input_zone: int, 
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
			[0, setup_test_02, setup_marbles_null], [1, setup_test_01, setup_marbles_null],
			[2, setup_test_02, setup_marbles_null], [3, setup_test_01, setup_marbles_null],
			[4, setup_test_02, setup_marbles_null], [5, setup_test_01, setup_marbles_null]
			]
	) -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(
		input_zone,
		marble.red,
		gates_setup, 
		marbles_setup)
		
	var next_marbles = next_state["marbles"]
	assert_that(next_marbles[0][input_zone/2]).is_not_null()
	
	var next_gates = next_state["gates"]
	assert_that(next_gates[0][input_zone/2]).is_equal(gates_setup[0][input_zone/2])

func test_close_path_02(
	  input_zone: int, 
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
			[0, setup_test_01, setup_marbles_null], [1, setup_test_02, setup_marbles_null],
			[2, setup_test_01, setup_marbles_null], [3, setup_test_02, setup_marbles_null],
			[4, setup_test_01, setup_marbles_null], [5, setup_test_02, setup_marbles_null]
			]
	) -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(
		input_zone,
		marble.red,
		gates_setup, 
		marbles_setup)
		
	var next_marbles = next_state["marbles"]
	assert_that(next_marbles[0][input_zone/2]).is_null()
	
	var next_gates = next_state["gates"]
	assert_that(next_gates[0][input_zone/2]).is_equal(-gates_setup[0][input_zone/2])

func test_output_matrix_shape() -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(
		0,
		marble.red,
		setup_test_00, 
		setup_marbles_null)
		
	var next_marbles = next_state["marbles"]
	assert_that(len(next_marbles[0])).is_equal(3)
	assert_that(len(next_marbles[1])).is_equal(4)
	assert_that(len(next_marbles[2])).is_equal(3)
	assert_that(len(next_marbles[3])).is_equal(4)
	
	var next_gates = next_state["gates"]
	assert_that(len(next_gates[0])).is_equal(3)
	assert_that(len(next_gates[1])).is_equal(4)
	assert_that(len(next_gates[2])).is_equal(3)
	assert_that(len(next_gates[3])).is_equal(4)
	
func test_open_path_prediction() -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(
		0,
		marble.yellow,
		open_path_0, 
		setup_marbles_null)
		
	var next_marbles = next_state["marbles"]
	assert_that(len(next_marbles[0])).is_equal(3)
	assert_that(len(next_marbles[1])).is_equal(4)
	assert_that(len(next_marbles[2])).is_equal(3)
	assert_that(len(next_marbles[3])).is_equal(4)
	
	var next_gates = next_state["gates"]
	assert_that(len(next_gates[0])).is_equal(3)
	assert_that(len(next_gates[1])).is_equal(4)
	assert_that(len(next_gates[2])).is_equal(3)
	assert_that(len(next_gates[3])).is_equal(4)
	
	var output_marbles = next_state["basket_marbles"]
	assert_that(len(output_marbles)).is_equal(1)
	assert_that(output_marbles[0]).is_equal(marble.yellow)

func test_close_path_prediction() -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(
		0,
		marble.yellow,
		semi_open_path_0, 
		setup_marbles_0)
		
	var next_marbles = next_state["marbles"]
	assert_that(len(next_marbles[0])).is_equal(3)
	assert_that(len(next_marbles[1])).is_equal(4)
	assert_that(len(next_marbles[2])).is_equal(3)
	assert_that(len(next_marbles[3])).is_equal(4)
	
	var next_gates = next_state["gates"]
	assert_that(len(next_gates[0])).is_equal(3)
	assert_that(len(next_gates[1])).is_equal(4)
	assert_that(len(next_gates[2])).is_equal(3)
	assert_that(len(next_gates[3])).is_equal(4)
	
	var output_marbles = next_state["basket_marbles"]
	assert_that(len(output_marbles)).is_equal(2)
	assert_array(output_marbles).contains_exactly_in_any_order([marble.yellow, marble.red])
	
func test_output_prediction(
	  expected_result: Array,
	  input_launch: int, 
	  input_color:int,
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
		[[marble.yellow, marble.green], 2, marble.yellow, close_path_0, setup_marbles_4],
		[[ marble.red, marble.green], 5, marble.green, close_path_4, setup_marbles_5],
		
	]
	) -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(
		input_launch,
		input_color,
		gates_setup, 
		marbles_setup)
		
	var next_marbles = next_state["marbles"]
	assert_that(len(next_marbles[0])).is_equal(3)
	assert_that(len(next_marbles[1])).is_equal(4)
	assert_that(len(next_marbles[2])).is_equal(3)
	assert_that(len(next_marbles[3])).is_equal(4)
	
	var next_gates = next_state["gates"]
	assert_that(len(next_gates[0])).is_equal(3)
	assert_that(len(next_gates[1])).is_equal(4)
	assert_that(len(next_gates[2])).is_equal(3)
	assert_that(len(next_gates[3])).is_equal(4)
	
	var output_marbles = next_state["basket_marbles"]
	assert_that(len(output_marbles)).is_equal(len(expected_result))
	assert_array(output_marbles).contains_exactly_in_any_order(expected_result)

func test_lvl0_prediction(
	  input_launch: int, 
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
		[0, open_path_0, setup_marbles_null],
		[1, open_path_1, setup_marbles_null],
		[2, open_path_2, setup_marbles_null],
		[3, open_path_3, setup_marbles_null],
		[4, open_path_4, setup_marbles_null],
		[5, open_path_5, setup_marbles_null],
		]
	) -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(
		input_launch,
		marble.red,
		gates_setup, 
		marbles_setup)
		
	var prev_gates_lvl0 = gates_setup[0]
	var next_gates_lvl0 = next_state["gates"][0]
	assert_that(next_gates_lvl0[input_launch/2]).is_equal(-prev_gates_lvl0[input_launch/2])
	var output_marbles = next_state["basket_marbles"]
	assert_that(len(output_marbles)).is_equal(1)
	
func test_lvl1_prediction(
	  input_launch: int, 
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
		[0, open_path_0, setup_marbles_null],
		[1, open_path_1, setup_marbles_null],
		[2, open_path_2, setup_marbles_null],
		[3, open_path_3, setup_marbles_null],
		[4, open_path_4, setup_marbles_null],
		[5, open_path_5, setup_marbles_null],
		]
	) -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(
		input_launch,
		marble.red,
		gates_setup, 
		marbles_setup)
		
	var prev_gates_lvl1 = gates_setup[1]
	var next_gates_lvl1 = next_state["gates"][1]
	var column = (input_launch+1)/2 
	assert_that(next_gates_lvl1[column]).is_equal(-prev_gates_lvl1[column])
	var output_marbles = next_state["basket_marbles"]
	assert_that(len(output_marbles)).is_equal(1)

func test_find_open_path(
	  expected_result: int, 
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
		[0, open_path_0, setup_marbles_null],
		[1, open_path_1, setup_marbles_null],
		[2, open_path_2, setup_marbles_null],
		[3, open_path_3, setup_marbles_null],
		[4, open_path_4, setup_marbles_null],
		[5, open_path_5, setup_marbles_null],
		[-1, semi_open_path_5, setup_marbles_null]
		]
	) -> void:
	var solver = auto_free(solver_src.new())
	var result = solver.find_open_path(gates_setup)
	assert_int(result).is_equal(expected_result)

func test_no_semi_open_path(
	  expected_result: int, 
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
		[-1, semi_open_path_0, setup_marbles_null],
		[-1, semi_open_path_1, setup_marbles_null],
		[-1, semi_open_path_2, setup_marbles_null],
		[-1, semi_open_path_3, setup_marbles_null],
		[-1, semi_open_path_4, setup_marbles_null],
		[-1, semi_open_path_5, setup_marbles_null]
		]
	) -> void:
	var solver = auto_free(solver_src.new())
	var result = solver.find_semi_open_path(gates_setup, marbles_setup)
	assert_int(result).is_equal(expected_result)

func test_find_semi_open_path(
	  expected_result: int, 
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
		[0, semi_open_path_0, setup_marbles_0],
		[1, semi_open_path_1, setup_marbles_1],
		[2, semi_open_path_2, setup_marbles_1],
		[3, semi_open_path_3, setup_marbles_2],
		[4, semi_open_path_4, setup_marbles_2],
		[5, semi_open_path_5, setup_marbles_3]
		]
	) -> void:
	var solver = auto_free(solver_src.new())
	var result = solver.find_semi_open_path(gates_setup, marbles_setup)
	assert_int(result).is_equal(expected_result)
	
func test_predict_semi_open_path(
	  input_launch: int, 
	  gates_setup: Array,
	  marbles_setup: Array,
	  test_parameters := [
		[0, semi_open_path_0, setup_marbles_0],
		[1, semi_open_path_1, setup_marbles_1],
		[2, semi_open_path_2, setup_marbles_1],
		[3, semi_open_path_3, setup_marbles_2],
		[4, semi_open_path_4, setup_marbles_2],
		[5, semi_open_path_5, setup_marbles_3]
		]
	) -> void:
	var solver = auto_free(solver_src.new())
	var next_state = solver.next_position(input_launch, marble.red, gates_setup, marbles_setup)
	var output_marbles = next_state["basket_marbles"]
	assert_that(len(output_marbles)).is_equal(2)


func test_open_lvl0_gates(
	expect_results: Array,	
	gates_setup: Array,
	test_parameters := [
		[open_lvl0_gates_0, close_path_0],
		[open_lvl0_gates_1, close_path_1],
		[open_lvl0_gates_2, close_path_2],
		[open_lvl0_gates_3, close_path_3]
		]
) -> void:
	var solver = auto_free(solver_src.new())
	var results = solver.open_lvl0_gates(gates_setup)
	# remove this line and complete your test
	assert_array(results).is_equal(expect_results)
