extends GdUnitTestSuite

@warning_ignore('unused_parameter')
@warning_ignore('return_value_discarded')
const __source = 'res://src/marble.gd'
var marble_gd = preload(__source)

const time_up = 20000

var setup_test_00 = [
	  [0,1,0],
	[0,-1,0,0],
	  [0,1,0],
	[0,1,0,0]
]
var setup_test_01 = [
	  [0,1,0],
	[0,1,-1,0],
	  [0,1,0],
	[0,1,0,0]
]
var setup_test_02 = [
	  [0,-1,0],
	[0,1,-1,0],
	  [0,1,0],
	[0,1,0,0]
]
var setup_test_06 = [
	  [-1,1,-1],
	[1,1,-1,1],
	  [1,1,-1],
	[-1,-1,1,1]
]

var setup_marbles_00 = [
		   [null, null, null],
		[null, null, null, null],
		   [null, null, null],
		[null, null, null, null]
]
var setup_marbles_01 = [
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.red, marble_gd.red, null, marble_gd.red],
		   [marble_gd.yellow, marble_gd.yellow, marble_gd.yellow],
		[marble_gd.green, marble_gd.green, marble_gd.green, marble_gd.green]
]


func test_extra_marbles_pvp(launch_zone_name:String, setup_gates:Array, setup_marbles:Array,
	test_parameters := [
		# ["LaunchZone3", setup_test_06, setup_marbles_All], #It seems it does not block anymore
		["LaunchZone3", setup_test_06, setup_marbles_01],
		#["LaunchZone1", setup_test_06, setup_marbles_02],
		]):
			
	var runner = scene_runner("res://src/pvp_trainning_room.tscn")
	var pvp_scn = runner.invoke("find_child", "Pvp")
	
	
	var zone2avoid = runner.invoke("find_child","ToBeAvoid")
	
	var board = pvp_scn.find_child("Board")
	var play_button = pvp_scn.find_child("BotonConfirm")
	play_button.show()
	
	board.clean_all()
	board.setup_internal_walls()
	var refs = board.setup_puzzle(setup_gates, setup_marbles)
	
	var marble_scn = load("res://src/marble.tscn")
	var new_marble = marble_scn.instantiate()
	new_marble.name = "Marbleuina"
	new_marble.set_color(marble_gd.red)
	var y = 0
	var x = 330.5
	new_marble.position = Vector2(x,y)
	pvp_scn.add_child(new_marble)
	
	pvp_scn.launch_input_choice = launch_zone_name
	var marble_source = pvp_scn.find_child("Sources")
	marble_source.color = "green"
	var human_board = pvp_scn.find_child("FancyScoreBoard1")
	human_board.target_marbles = [0,1,2,0,1,2,0,1,2]
	pvp_scn.start_turn()
	
	var marbles = []
	var types = []
	var names = []
	var colors = []
	for node in pvp_scn.get_children():
		var node_class = node.get_class()
		types.append(node_class)
		names.append(node.name)
		if node_class.ends_with("RigidBody2D") and not node.name.ends_with("Goal"):
			colors.append(node.get_color())
			marbles.append(node)
			
			
	await assert_signal(pvp_scn).wait_until(time_up).is_emitted("marble_jam")
	await assert_signal(pvp_scn).wait_until(time_up).is_emitted("end_turn")

func test_extra_marbles_AI(launch_zone_name:String, setup_gates:Array, setup_marbles:Array,
	test_parameters := [
		# ["LaunchZone3", setup_test_06, setup_marbles_All], #It seems it does not block anymore
		["LaunchZone3", setup_test_06, setup_marbles_01],
		#["LaunchZone1", setup_test_06, setup_marbles_02],
		]):
			
	var runner = scene_runner("res://src/pvAI_trainning_room.tscn")
	var pvp_scn = runner.invoke("find_child", "PvAI")
	
	
	var zone2avoid = runner.invoke("find_child","ToBeAvoid")
	
	var board = pvp_scn.find_child("Board")
	var play_button = pvp_scn.find_child("BotonConfirm")
	play_button.show()
	
	board.clean_all()
	board.setup_internal_walls()
	var refs = board.setup_puzzle(setup_gates, setup_marbles)
	
	var marble_scn = load("res://src/marble.tscn")
	var new_marble = marble_scn.instantiate()
	new_marble.name = "Marbleuina"
	new_marble.set_color(marble_gd.red)
	var y = 0
	var x = 330.5
	new_marble.position = Vector2(x,y)
	pvp_scn.add_child(new_marble)
	
	pvp_scn.launch_input_choice = launch_zone_name
	var marble_source = pvp_scn.find_child("Sources")
	marble_source.color = "green"
	var human_board = pvp_scn.find_child("FancyScoreBoard1")
	human_board.target_marbles = [0,1,2,0,1,2,0,1,2]
	pvp_scn.start_turn()
	
	var marbles = []
	var types = []
	var names = []
	var colors = []
	for node in pvp_scn.get_children():
		var node_class = node.get_class()
		types.append(node_class)
		names.append(node.name)
		if node_class.ends_with("RigidBody2D") and not node.name.ends_with("Goal"):
			colors.append(node.get_color())
			marbles.append(node)
			
			
	await assert_signal(pvp_scn).wait_until(time_up).is_emitted("marble_jam")
	await assert_signal(pvp_scn).wait_until(time_up).is_emitted("end_turn")
	
